/*===========================================================================*\
| GOOF.C - Displays fatal programming errors                ver 2.1, 07-22-89 |
|                                                                             |
| This file contains a convenient way to alert you of programming errors      |
| since it is possible to create unseen errors with virtual and hidden        |
| windows.  You can edit and recompile this module, then re-link it with      |
| your program.                                                               |
|   Copyright (C) 1989 by James H. LeMay,  All rights reserved.               |
|   Conversion to Turbo C by Jordan Gallagher/Wisdom Research                 |
\*===========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#endif
#include <process.h>

#include "wndwc21.h"


#ifndef __TURBOC__
/*================================| lheapavl |===============================*\
Returns heap space available
\*===========================================================================*/
long lheapavl(void)
{
   unsigned int hilim = 65535;
   unsigned int lolim = 0;
   unsigned int request = hilim;
   unsigned int *mptr;

   while(1)     /* repeat indefinitely */
   {
      if (mptr = (unsigned int *) malloc(request))  /* can we allocate it? */
      {
         free ((void *) mptr);                      /* yes, free it        */
         lolim = request;                           /* set lower limit     */
      }
      else
         hilim = request;                           /* no, set upper limit */

      request = (((unsigned) ((hilim - lolim) >> 1)) + lolim);

      if (request <= lolim)
         break;
   }
   return ((long) lolim);
}
#endif


/*==============================| showgoof |================================*\
Shows an error ("goof") message when a fatal window error occurs.
\*==========================================================================*/
void showgoof( char errornum )
{
    char msg1[40],msg2[40],core[40],farcore[40];

    strcpy( msg2, "" );
    switch(errornum) {
        case 1:
            strcpy( msg1, "Not enough Heap space!" );
#ifdef __TURBOC__
            ltoa(coreleft(),core,10);
            ltoa(farcoreleft(),farcore,10);
            strcpy( msg2, "core=" );      strcat( msg2, core );
            strcat( msg2, "/farcore=" );  strcat(msg2,farcore);   break;
#else
            ltoa(lheapavl(),core,10);
            strcpy( msg2, "Heap space: " ); strcat( msg2, core ); break;
#endif
        case 2: strcpy( msg1, "Too many windows!" );              break;
        case 3: strcpy( msg1, "Too many virtual windows!" );      break;
        case 4: strcpy( msg1, "Perm window out of order!" );      break;
        case 5: strcpy( msg1, "No window to remove!" );           break;
        case 6: strcpy( msg1, "Hidden window not found!" );       break;
        case 7: strcpy( msg1, "Virtual screen not found!" );      break;
        case 8: strcpy( msg1, "Video page not available!" );      break;
    }
    li = 0;                       /* Set top window level */
    topwndwstat = wndwstat[0];    /* Get original CRT stat */
    qscr = tws.vscr;              /* Set QWIKC stats */
    qwritepage(0);                /* Ensure we are writing to page 0 */
    qviewpage(0);                 /* Ensure we are viewing page 0 */
    windowmodes = RELMODE;
    makewindow( 0, 0, 5, 42, LIGHTGRAY_BG, LIGHTGRAY_BG+BLINK,
                DOUBLE_BORDER, AWINDOW );
    wwritec( 1, msg1 );
    wwritec( 2, msg2 );
    wwritec( 3, "Program halted." );
    setcursor( cursor_initial );
    exit(1);
}
