/*******************************************************************************
**                                                                            **
**                      Kermit for Microsoft Windows                          **
**                      ----------------------------                          **
**                                KERMDLG.C                                   **
**                                                                            **
**  This module contains the common dialog procedures.  It also contains      **
**  miscellaneous helper routines.                                            **
**                                                                            **
*******************************************************************************/

// INCLUDES -------------------------------------------------------------------

#include "kermit.h"

//-----------------------------------------------------------------------------
int NEAR GetRadioButton(HWND hDlg, int nIDFirstButton, int nIDLastButton)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    int i;

    for (i = nIDFirstButton; i <= nIDLastButton; i++) {
        if (IsDlgButtonChecked(hDlg, i))
            return(i);
    }

    return(0);
}

//-----------------------------------------------------------------------------
BOOL GetValidDlgItemInt(HWND hDlg, WORD wItem, BOOL Signed,
                        WORD *Parm, WORD LoVal, WORD HiVal)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    WORD x;
    BOOL b;

    x = GetDlgItemInt(hDlg, wItem, &b, Signed);
    if (b && (x >= LoVal && x <= HiVal)) {
        *Parm = x;
        return(TRUE);
    }
    else {
        SetFocus(GetDlgItem(hDlg, wItem));
        MessageBeep(0);
        return(FALSE);
    }
}

//-----------------------------------------------------------------------------
BOOL GetValidDlgItemIntX(HWND hDlg, WORD wItem, BOOL Signed,
                        WORD *Parm, WORD LoVal, WORD HiVal, WORD OthVal)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    WORD x;
    BOOL b;

    x = GetDlgItemInt(hDlg, wItem, &b, Signed);
    if (b && ((x >= LoVal && x <= HiVal)) || (x == OthVal)) {
        *Parm = x;
        return(TRUE);
    }
    else {
        SetFocus(GetDlgItem(hDlg, wItem));
        MessageBeep(0);
        return(FALSE);
    }
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL AboutDlgProc(HWND hDlg, unsigned message,
                             WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_OK:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
            }
            break;

        default:
            return(FALSE);
    }
    return(TRUE);
}
     
//-----------------------------------------------------------------------------
BOOL NEAR TermDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    CheckDlgButton(hDlg, IDD_NEWLINE, TermSet.NewLine);
    CheckDlgButton(hDlg, IDD_LOCALECHO, TermSet.LocalEcho);
    CheckDlgButton(hDlg, IDD_LINEWRAP, TermSet.LineWrap);

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR TermDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    TermBlk TermWrk;

    memcpy(&TermWrk, &TermSet, sizeof(TermBlk));

    TermWrk.NewLine = IsDlgButtonChecked(hDlg, IDD_NEWLINE);
    TermWrk.LocalEcho = IsDlgButtonChecked(hDlg, IDD_LOCALECHO);
    TermWrk.LineWrap = IsDlgButtonChecked(hDlg, IDD_LINEWRAP);

    memcpy(&TermSet, &TermWrk, sizeof(TermBlk));

    if (IsDlgButtonChecked(hDlg, IDD_SAVE)) {
        char szBuf[96];
        sprintf(szBuf, "%u %u %u %u %u",
                TermSet.Emulation, TermSet.NewLine,
                TermSet.LocalEcho, TermSet.LineWrap,
                TermSet.TextSize);
        WriteProfileString(szAppName, "Term", szBuf);
    }

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL TermDlgProc(HWND hDlg, unsigned message,
                            WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_OK:
                    if (!TermDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(TermDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}
     
//-----------------------------------------------------------------------------
BOOL NEAR CommDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    SetDlgItemInt(hDlg, IDD_BAUDRATE, CommSet.BaudRate, FALSE);
    CheckRadioButton(hDlg, IDD_4DATABITS, IDD_8DATABITS,
                     (CommSet.DataBits + IDD_4DATABITS - 4));
    CheckRadioButton(hDlg, IDD_NOPTY, IDD_EVENPTY,
                     (CommSet.Parity + IDD_NOPTY));
    CheckRadioButton(hDlg, IDD_1STOPBIT, IDD_2STOPBITS,
                     (CommSet.StopBits + IDD_1STOPBIT));
    CheckDlgButton(hDlg, IDD_FLOWCTL, CommSet.FlowControl);
    CheckDlgButton(hDlg, IDD_HANDSHK, CommSet.HandShake);
    CheckRadioButton(hDlg, IDD_COM1, IDD_COM2,
                     (CommSet.CommPort + IDD_COM1));

    EnableWindow(GetDlgItem(hDlg, IDD_COM1), !bConnected);
    EnableWindow(GetDlgItem(hDlg, IDD_COM2), !bConnected);

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR CommDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    CommBlk CommWrk;

    memcpy(&CommWrk, &CommSet, sizeof(CommBlk));

    CommWrk.BaudRate = GetDlgItemInt(hDlg, IDD_BAUDRATE, NULL, FALSE);
    CommWrk.DataBits = GetRadioButton(hDlg, IDD_4DATABITS, IDD_8DATABITS)
                       - IDD_4DATABITS + 4;
    CommWrk.Parity = GetRadioButton(hDlg, IDD_NOPTY, IDD_EVENPTY) - IDD_NOPTY;
    CommWrk.StopBits = GetRadioButton(hDlg, IDD_1STOPBIT, IDD_2STOPBITS)
                       - IDD_1STOPBIT;
    CommWrk.FlowControl = IsDlgButtonChecked(hDlg, IDD_FLOWCTL);
    CommWrk.HandShake = IsDlgButtonChecked(hDlg, IDD_HANDSHK);
    CommWrk.CommPort = GetRadioButton(hDlg, IDD_COM1, IDD_COM2) - IDD_COM1;

    memcpy(&CommSet, &CommWrk, sizeof(CommBlk));

    if (IsDlgButtonChecked(hDlg, IDD_SAVE)) {
        char szBuf[96];
        sprintf(szBuf, "%u %u %u %u %u %u %u",
                CommSet.CommPort, CommSet.BaudRate,
                CommSet.DataBits, CommSet.Parity,
                CommSet.StopBits, CommSet.FlowControl,
                CommSet.HandShake);
        WriteProfileString(szAppName, "Comm", szBuf);
    }

    if (bConnected)
        SetupComm();

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL CommDlgProc(HWND hDlg, unsigned message,
                            WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    static CommBlk CommWrk;
     
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_4DATABITS:
                case IDD_5DATABITS:
                case IDD_6DATABITS:
                case IDD_7DATABITS:
                case IDD_8DATABITS:
                    CheckRadioButton(hDlg, IDD_4DATABITS,
                                     IDD_8DATABITS, wParam);
                    break;


                case IDD_NOPTY:
                case IDD_ODDPTY:
                case IDD_EVENPTY:
                    CheckRadioButton(hDlg, IDD_NOPTY, IDD_EVENPTY, wParam);
                    break;

                case IDD_1STOPBIT:
                case IDD_1HSTOPBITS:
                case IDD_2STOPBITS:
                    CheckRadioButton(hDlg, IDD_1STOPBIT,
                                     IDD_2STOPBITS, wParam);
                    break;

                case IDD_COM1:
                case IDD_COM2:
                    CheckRadioButton(hDlg, IDD_COM1, IDD_COM2, wParam);
                    break;

                case IDD_OK:
                    if (!CommDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, NULL);
                    return(TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(CommDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}
     
//-----------------------------------------------------------------------------
BOOL NEAR ModemDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR ModemDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
//    ModemBlk ModemWrk;

//    memcpy(&ModemWrk, &ModemSet, sizeof(ModemBlk));

//    memcpy(&ModemSet, &ModemWrk, sizeof(ModemBlk));

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL ModemDlgProc(HWND hDlg, unsigned message,
                             WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_OK:
                    if (!ModemDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(ModemDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR ProtocolDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    SetDlgItemInt(hDlg, IDD_SPKTSIZE, ProtSet.SendPktSize, FALSE);
    SetDlgItemInt(hDlg, IDD_RPKTSIZE, ProtSet.RecvPktSize, FALSE);
    SetDlgItemInt(hDlg, IDD_STIMEOUT, ProtSet.SendTimeout, FALSE);
    SetDlgItemInt(hDlg, IDD_RTIMEOUT, ProtSet.RecvTimeout, FALSE);
    SetDlgItemInt(hDlg, IDD_SLIMIT, ProtSet.RetryLimit, FALSE);
    CheckRadioButton(hDlg, IDD_BCHK1, IDD_BCHK3,
                     (ProtSet.BlockCheck + IDD_BCHK1));
    CheckDlgButton(hDlg, IDD_PKTDBG, ProtSet.DebugPacket);
    CheckDlgButton(hDlg, IDD_STADBG, ProtSet.DebugState);
    CheckDlgButton(hDlg, IDD_OTHDBG, ProtSet.DebugOther);
    CheckDlgButton(hDlg, IDD_ATRCAP, ProtSet.Attributes);
    CheckDlgButton(hDlg, IDD_LNGCAP, ProtSet.LongPackets);
    CheckDlgButton(hDlg, IDD_WNDCAP, ProtSet.Windowing);

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR ProtocolDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    ProtBlk ProtWrk;

    memcpy(&ProtWrk, &ProtSet, sizeof(ProtBlk));

    if (!GetValidDlgItemIntX(hDlg, IDD_SPKTSIZE, FALSE, &ProtWrk.SendPktSize,
                           20, 94, 1000))
        return(FALSE);
    if (!GetValidDlgItemIntX(hDlg, IDD_RPKTSIZE, FALSE, &ProtWrk.RecvPktSize,
                           20, 94, 1000))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_STIMEOUT, FALSE,
                            &ProtWrk.SendTimeout, 0, 99))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RTIMEOUT, FALSE,
                           &ProtWrk.RecvTimeout, 0, 99))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_SLIMIT, FALSE,
                           &ProtWrk.RetryLimit, 0, 99))
        return(FALSE);

    ProtWrk.BlockCheck = GetRadioButton(hDlg, IDD_BCHK1, IDD_BCHK3)
                         - IDD_BCHK1;

    ProtWrk.DebugPacket = IsDlgButtonChecked(hDlg, IDD_PKTDBG);
    ProtWrk.DebugState = IsDlgButtonChecked(hDlg, IDD_STADBG);
    ProtWrk.DebugOther = IsDlgButtonChecked(hDlg, IDD_OTHDBG);

    ProtWrk.Attributes = IsDlgButtonChecked(hDlg, IDD_ATRCAP);
    ProtWrk.LongPackets = IsDlgButtonChecked(hDlg, IDD_LNGCAP);
    ProtWrk.Windowing = IsDlgButtonChecked(hDlg, IDD_WNDCAP);

    memcpy(&ProtSet, &ProtWrk, sizeof(ProtBlk));

    if (IsDlgButtonChecked(hDlg, IDD_SAVE)) {
        char szBuf[96];
        sprintf(szBuf, "%u %u %u %u %u %u %u %u %u %u %u %u",
                ProtSet.SendPktSize, ProtSet.RecvPktSize,
                ProtSet.SendTimeout, ProtSet.RecvTimeout,
                ProtSet.RetryLimit, ProtSet.BlockCheck,
                ProtSet.DebugPacket, ProtSet.DebugState,
                ProtSet.DebugOther, ProtSet.Attributes,
                ProtSet.LongPackets, ProtSet.Windowing);
        WriteProfileString(szAppName, "Protocol", szBuf);
    }

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL ProtocolDlgProc(HWND hDlg, unsigned message,
                                WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_BCHK1:
                case IDD_BCHK2:
                case IDD_BCHK3:
                    CheckRadioButton(hDlg, IDD_BCHK1, IDD_BCHK3, wParam);
                    break;

                case IDD_OK:
                    if (!ProtocolDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(ProtocolDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}
     
//-----------------------------------------------------------------------------
BOOL NEAR PacketsDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    SetDlgItemInt(hDlg, IDD_SPADCHR, PktSet.Send.PadChar, FALSE);
    SetDlgItemInt(hDlg, IDD_RPADCHR, PktSet.Recv.PadChar, FALSE);
    SetDlgItemInt(hDlg, IDD_SPADCNT, PktSet.Send.PadCount, FALSE);
    SetDlgItemInt(hDlg, IDD_RPADCNT, PktSet.Recv.PadCount, FALSE);
    SetDlgItemInt(hDlg, IDD_SPKTSOP, PktSet.Send.StartChar, FALSE);
    SetDlgItemInt(hDlg, IDD_RPKTSOP, PktSet.Recv.StartChar, FALSE);
    SetDlgItemInt(hDlg, IDD_SPKTEOL, PktSet.Send.EndChar, FALSE);
    SetDlgItemInt(hDlg, IDD_RPKTEOL, PktSet.Recv.EndChar, FALSE);
    SetDlgItemInt(hDlg, IDD_SCTLPFX, PktSet.Send.CtlPrefix, FALSE);
    SetDlgItemInt(hDlg, IDD_RCTLPFX, PktSet.Recv.CtlPrefix, FALSE);

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR PacketsDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    PktBlk PktWrk;

    memcpy(&PktWrk, &PktSet, sizeof(PktBlk));

    if (!GetValidDlgItemInt(hDlg, IDD_SPADCHR, FALSE,
                            &PktWrk.Send.PadChar, 0, 31))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RPADCHR, FALSE,
                            &PktWrk.Recv.PadChar, 0, 31))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_SPADCNT, FALSE,
                            &PktWrk.Send.PadCount, 0, 99))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RPADCNT, FALSE,
                            &PktWrk.Recv.PadCount, 0, 99))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_SPKTSOP, FALSE,
                            &PktWrk.Send.StartChar, 0, 31))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RPKTSOP, FALSE,
                            &PktWrk.Recv.StartChar, 0, 31))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_SPKTEOL, FALSE,
                            &PktWrk.Send.EndChar, 0, 31))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RPKTEOL, FALSE,
                            &PktWrk.Recv.EndChar, 0, 31))
        return(FALSE);

    if (!GetValidDlgItemInt(hDlg, IDD_SCTLPFX, FALSE,
                            &PktWrk.Send.CtlPrefix, 33, 126))
        return(FALSE);
    if (!GetValidDlgItemInt(hDlg, IDD_RCTLPFX, FALSE,
                            &PktWrk.Recv.CtlPrefix, 33, 126))
        return(FALSE);

    memcpy(&PktSet, &PktWrk, sizeof(PktBlk));

    if (IsDlgButtonChecked(hDlg, IDD_SAVE)) {
        char szBuf[96];
        sprintf(szBuf, "%u %u %u %u %u %u %u %u %u %u",
                PktSet.Send.PadChar, PktSet.Send.PadCount,
                PktSet.Send.StartChar, PktSet.Send.EndChar,
                PktSet.Send.CtlPrefix, PktSet.Recv.PadChar,
                PktSet.Recv.PadCount, PktSet.Recv.StartChar,
                PktSet.Recv.EndChar, PktSet.Recv.CtlPrefix);
        WriteProfileString(szAppName, "Packets", szBuf);
    }

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL PacketsDlgProc(HWND hDlg, unsigned message,
                               WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_OK:
                    if (!PacketsDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(PacketsDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}
     
//-----------------------------------------------------------------------------
BOOL NEAR LoggingDlgInit(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    CheckDlgButton(hDlg, IDD_LOGSESFLG, LogSet.SessionLogFlag);
    SetDlgItemText(hDlg, IDD_LOGSESFIL, LogSet.SessionLogName);
    CheckDlgButton(hDlg, IDD_LOGPKTFLG, LogSet.PacketLogFlag);
    SetDlgItemText(hDlg, IDD_LOGPKTFIL, LogSet.PacketLogName);
    CheckDlgButton(hDlg, IDD_LOGTRNFLG, LogSet.TransLogFlag);
    SetDlgItemText(hDlg, IDD_LOGTRNFIL, LogSet.TransLogName);

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL NEAR LoggingDlgTerm(HWND hDlg)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    LogBlk LogWrk;

    memcpy(&LogWrk, &LogSet, sizeof(LogBlk));

    LogWrk.SessionLogFlag = IsDlgButtonChecked(hDlg, IDD_LOGSESFLG);
    LogWrk.PacketLogFlag = IsDlgButtonChecked(hDlg, IDD_LOGPKTFLG);
    LogWrk.TransLogFlag = IsDlgButtonChecked(hDlg, IDD_LOGTRNFLG);

    GetDlgItemText(hDlg, IDD_LOGSESFIL, LogWrk.SessionLogName,
                   sizeof(LogWrk.SessionLogName));
    GetDlgItemText(hDlg, IDD_LOGPKTFIL, LogWrk.PacketLogName,
                   sizeof(LogWrk.PacketLogName));
    GetDlgItemText(hDlg, IDD_LOGTRNFIL, LogWrk.TransLogName,
                   sizeof(LogWrk.TransLogName));

    memcpy(&LogSet, &LogWrk, sizeof(LogBlk));

    if (IsDlgButtonChecked(hDlg, IDD_SAVE)) {
        char szBuf[96];
        sprintf(szBuf, "%u %s", LogSet.SessionLogFlag,
                                LogSet.SessionLogName);
        WriteProfileString(szAppName, "SessionLog", szBuf);
        sprintf(szBuf, "%u %s", LogSet.PacketLogFlag,
                                LogSet.PacketLogName);
        WriteProfileString(szAppName, "PacketLog", szBuf);
        sprintf(szBuf, "%u %s", LogSet.TransLogFlag,
                                LogSet.TransLogName);
        WriteProfileString(szAppName, "TransLog", szBuf);
    }

    return(TRUE);
}

//-----------------------------------------------------------------------------
BOOL FAR PASCAL LoggingDlgProc(HWND hDlg, unsigned message,
                               WORD wParam, LONG lParam)

//  Description of what function does.

//  Param(s):   x...............Description.

//  Returns:    Result description.

{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDD_OK:
                    if (!LoggingDlgTerm(hDlg))
                        break;

                case IDD_CANCEL:
                    EndDialog(hDlg, TRUE);
                    break;

                default:
                    return(FALSE);
                    break;
            }
            break;

        case WM_INITDIALOG:
            return(LoggingDlgInit(hDlg));

        default:
            return(FALSE);
    }
    return(TRUE);
}
