'*  QBFCOMMS.BI
'*--------------------------------------------------------------------------
'*
'*  Included header file for the QBFCOMMS.BAS routines.
'*

' $INCLUDE: 'QB.BI'

'*
'* Include declarations for the QuickBASIC HLLAPIs
'*
DECLARE SUB QBX00 (InRegs AS RegType, OutRegs AS RegType)
DECLARE SUB QBX00X (InRegs AS RegTypeX, OutRegs AS RegTypeX)

'*
'* Include declarations for the QBFCOMMS functions
'*
DECLARE FUNCTION FossilAnsiPrint% (A$)
DECLARE FUNCTION FossilBIOSPrint% (A$)
DECLARE FUNCTION FossilBreak% (Port%, Ctrl%)
DECLARE FUNCTION FossilCtrlKCtrlC% (Port%, Ctrl%)
DECLARE FUNCTION FossilDTR% (Port%, Ctrl%)
DECLARE FUNCTION FossilDeactivate% (Port%)
DECLARE FUNCTION FossilFlowControl% (Port%, Ctrl%)
DECLARE FUNCTION FossilFlush% (Port%)
DECLARE FUNCTION FossilGetb% (Port%, Buffer$, Length%)
DECLARE FUNCTION FossilGetch$ (Port%)
DECLARE FUNCTION FossilInfo% (Port%, Rev%, Ver%, ID$, ISZ%, IFR%, OSZ%, OFR%, SW%, SH%, Baud&)
DECLARE FUNCTION FossilInit% (Port%)
DECLARE FUNCTION FossilInkey% ()
DECLARE FUNCTION FossilInkeyWait% ()
DECLARE FUNCTION FossilLocate% (Row%, Column%)
DECLARE FUNCTION FossilPeek$ (Port%)
DECLARE FUNCTION FossilPurgeInputBuf% (Port%)
DECLARE FUNCTION FossilPurgeOutputBuf% (Port%)
DECLARE FUNCTION FossilPutb% (Port%, Buffer$)
DECLARE FUNCTION FossilPutch% (Port%, Char$)
DECLARE FUNCTION FossilPutchWait% (Port%, Char$)
DECLARE FUNCTION FossilReadCursor% (Row%, Column%)
DECLARE FUNCTION FossilReboot% (Ctrl%)
DECLARE FUNCTION FossilSetBaud% (Port%, BaudRate&)
DECLARE FUNCTION FossilStatus% (Port%)
DECLARE FUNCTION FossilWatchdog% (Port%, Ctrl%)

'*
'* Define a structure for FossilInfo()
'*
TYPE FossilInfoType
   StructSize AS INTEGER
   MajorVersion AS STRING * 1
   MinorVersion AS STRING * 1
   IdentOffset AS INTEGER
   IdentSegment AS INTEGER
   InBufrSize AS INTEGER
   InBufrFree AS INTEGER
   OutBufrSize AS INTEGER
   OutBufrFree AS INTEGER
   ScreenWidth AS STRING * 1
   ScreenHeight AS STRING * 1
   Baud AS STRING * 1
END TYPE

'*
'* Define some port values
'*
      CONST COM0 = &HFF                   ' Local mode
      CONST COM1 = 0
      CONST COM2 = 1
      CONST COM3 = 2
      CONST COM4 = 3

'*
'* Define the values to be used with FossilFlowControl()
'*
'* Add these together to enable multiple types, i.e.
'*
'*   X = FossilFlowControl(COM1, XOnXOffXmit + XOnXoffRecv)
'*
      CONST NoFlow = 0
      CONST XOnOffXmit = 1
      CONST CTSRTS = 2
      CONST XOnOffRecv = 8

'*
'* Define values to be passed to FossilCtrlKCtrlC()
'*
      CONST DisableCheck = 0
      CONST EnableCheck = 1
      CONST DisableXmitter = 0
      CONST EnableXmitter = 2

'*
'* Define some port status bits
'*
      CONST DCD = 128                    ' Carrier detect
      CONST RDA = 256                    ' Receive data available
      CONST OVRN = 512                   ' Input buffer overrun
      CONST THRE = 8192                  ' Output buffer not full
      CONST TSRE = 16384                 ' Output buffer empty

'*
'* Define some miscellaneous stuff
'*
      CONST TRUE = -1
      CONST FALSE = 0

